<?

/**
 * dbObject
 * This class represents a row in the database as an object
 */
class dbObject {
  
   /**
   * Name of the (current) database
   * @var String
   */
  public $sDataBase;
  
   /**
   * Name of the table in which the object is
   * @var String
   */
  public $sTablename;
  
   /**
   * Name of the primary key of the table
   * @var String
   */
  public $sKeyName;
  
   /**
   * All columns in the table
   * @var Array of dbAttributes
   */
 
  public $aAttributes=array();

  /**
   * Function to get a selection of objects that meet criteria in the parameter
   * @param(oSelect) Object with selection criteria
   * @param(oSelect->aAttributes) Array of selection criteria
   * @param(oSelect->orderby) Requested order of the resultset
   * @param(oSelect->offset) Requested offset for the resultset
   * @param(oSelect->size) Requested size of the resultset
   * @param(oSelect->found) Boolean for requesting the total count
   * @return(__oReturn) ArrayIterator containing the resultset of dbObjects
   * @return(__oReturn->count) Size of the resultset
   * @return(__oReturn->found) Total size of resultset
   */
  public static function get($oSelect) {

    // Begin of the select query
    $sSql = 'SELECT DISTINCT SQL_CALC_FOUND_ROWS `'.$oSelect->sKeyName.'` FROM `'.$oSelect->sDataBase.'`.`'.$oSelect->sTablename.'`';

    // Declare an array of 'WHERE' strings
    $aWhere = array();
    
    // For each criterium, the SQL has to be extended for further reduction of the resultset
    foreach($oSelect->aAttributes as $oAttribute) {
      //if($oSelect->getAttribute($oAttribute->sName)) {
      if($oAttribute->uValue) {
	// Extend the WHERE array
        $aWhere[] = $oAttribute->sName.'='.$oSelect->aAttributes[$oAttribute->sName]->formatQuotes();
      }
    }
    
    if(isset($oSelect->identifier)) {
     $sSql.= " WHERE `".$oSelect->sKeyName."` = ".$oSelect->identifier;
    }

    // If there are selection criteria, add them to the SQL
    if(count($aWhere) > 0) {
      $sSql .= " WHERE ".implode(' AND ',$aWhere);
    }

    // If the order by is set, extend the SQL
    if(isset($oSelect->orderby)) {
      $aOrder = explode(' ',$oSelect->orderby);
      $sSql.= ' ORDER BY `'.$aOrder[0].'` '.count($aOrder)>1?$aOrder[1]:'';
    } 

    // If the offset is set, add the offset to the SQL
    $iOffset = isset($oSelect->offset)?$oSelect->offset:0;
    
    // If the size is set, add it to the SQL, otherwise, limit to 50
    $iSize = isset($oSelect->size)?$oSelect->size:50;
    $sSql.= ' LIMIT '.$iOffset.', '.$iSize;

    // Declare return array and object
    $__oReturn = null;
    $__aReturn = array();
    // Query the SQL
    
    
    $aRows=mysql_query($sSql);
    if(!$aRows) return "error94";

    // If the total rows are requested, find them
    if(!isset($oSelect->found)) {
      $sSql="SELECT FOUND_ROWS() total";
      $oRowsTot=mysql_query($sSql);
      $oRow=mysql_fetch_array($oRowsTot,MYSQL_ASSOC);
      
      // Set the total found rows
      $oSelect->found = (int) $oRow['total'];
    }

    // Turn each found row to an object and add them to the return array
    while($aRow=mysql_fetch_array($aRows)) {
      $__aReturn[] = new dbObject($oSelect->sDataBase.'.'.$oSelect->sTablename,$aRow[$oSelect->sKeyName]);
    }

    // Instead of an array, we return an arrayiterator 
    $__oReturn = new ArrayIterator($__aReturn);
    
    // Set the size of the resultset
    $__oReturn->count = $__oReturn->count();
    
    // Set the total size of the resultset
    $__oReturn->found = $oSelect->found;

    // Return the arrayIterator
    return $__oReturn;
  }

  
  /**
   * Constructor of a dbObject, retreiving all the information of a databaserow
   * @param(sTableName) String of the tablename for the object
   * @param(iId) Primary key of the requested object
   */
  public function dbObject($sTableName,$iId=null) {
    
    // Fetch the global database as default
    global $sDataBase;
    
    // If a dot is in the tablename, everything before that is the databasename
    $aTableName = preg_split("/\./",$sTableName);
    
    // If so, set the values
    if(count($aTableName) > 1) {
      $sDataBase = $aTableName[0];
      $sTableName = $aTableName[1];
    }
    
    // check if the table exists
    $bCheckSql = "SELECT count(*) as 'exists' FROM information_schema.COLUMNS WHERE TABLE_NAME = '".$sTableName."' AND TABLE_SCHEMA = '".$sDataBase."';";
    
    $aRows = mysql_query($bCheckSql);
    
    // if the table doesn't exist, the primary key is passed
    if($aRow = mysql_fetch_array($aRows)) {
      if($aRow['exists']==0) {
	$sPrimarySql = "SELECT TABLE_NAME from information_schema.COLUMNS WHERE COLUMN_NAME = '".$sTableName."' AND COLUMN_KEY = 'PRI' AND TABLE_SCHEMA = '".$sDataBase."';";
	$aRows = mysql_query($sPrimarySql);
	if($aRow=mysql_fetch_array($aRows)) {
	  $sTableName = $aRow['TABLE_NAME'];
	} else {
	  return 'error91';
	}
      }
    }
    
    // Save the database in the object
    $this->sDataBase = $sDataBase;
    
    // Save the tablename in the object
    $this->sTablename = $sTableName;
    
    // Begin SQL
    $sSql = "SELECT * FROM `".$sDataBase."`.`".$sTableName.'`';
    
    // Read the internal information about the table using internal MySQL table information_schema.COLUMNS
    $sInfSql = "SELECT A.*, (B.COLUMN_NAME IS NOT NULL) as 'isforeign' 
		FROM information_schema.COLUMNS A 
		LEFT JOIN information_schema.COLUMNS B 
		  ON A.COLUMN_NAME = B.COLUMN_NAME
		  AND B.TABLE_SCHEMA = '".$sDataBase."'
		  AND B.COLUMN_KEY = 'PRI' 
		  AND A.TABLE_NAME != B.TABLE_NAME 
		WHERE A.TABLE_NAME = '".$sTableName."' 
		  AND A.TABLE_SCHEMA = '".$sDataBase."';";
    
    $aRows = mysql_query($sInfSql);
    // For each existing row, there has to be an attribute
    while($aRow=mysql_fetch_array($aRows)) {
      // Make new dbAttribute and set all its relevant values
      $oAttribute=new dbAttribute();
      $oAttribute->sName=$aRow['COLUMN_NAME'];
      $oAttribute->sType=$aRow['DATA_TYPE'];
      $oAttribute->iPosition=$aRow['ORDINAL_POSITION'];
      $oAttribute->uDefault=$aRow['COLUMN_DEFAULT'];
      $oAttribute->bNull=$aRow['IS_NULLABLE'];
      $oAttribute->iMaxLength=$aRow['CHARACTER_MAXIMUM_LENGTH'];
      $oAttribute->sCharacterSet=$aRow['CHARACTER_SET_NAME'];
      $oAttribute->sColumnType=$aRow['COLUMN_TYPE'];
      // check if the attrbute is a foreign key
      //$oAttribute->bForeignKey=($aRow['COLUMN_KEY']=='MUL' || $aRow['COLUMN_KEY']=='UNI');
      $oAttribute->bForeignKey=($aRow['isforeign']>0);
            
            
      // If the column is the primary key of the table, set the keyname
      if($aRow['COLUMN_KEY']=='PRI') {
	$this->sKeyName = $aRow['COLUMN_NAME'];
        $oAttribute->bPrimaryKey = true;
      }

      // Save the attribute to an array
      $this->aAttributes[$oAttribute->sName] = $oAttribute;

    }
    
    // Get all the information about the object
    $sSql.=' WHERE `'.$this->sKeyName.'` = '.$iId;
    
    
    // If the id exists, create an object with all its attributes, if not, the object is already finished
    if($iId > 0) {
      $aRows=mysql_query($sSql);
    if(!$aRows) return "error94";
    
      // If a row is found we can fill the object
      if($aRow=mysql_fetch_assoc($aRows)) {
      
	// For each found attribute
        foreach($aRow as $key=>$value) {
        
	  // Fill the attribute
          if(is_object($this->aAttributes[$key])) {
            $this->aAttributes[$key]->setValue($value);
          }
        }
      }
    }
  }

  /**
   * Function to get an attribute of the object
   * @param(sAttribute) String, the name of the column of the requested attribute
   * @return Value of the requested attribute
   */
  public function getAttribute($sAttribute) {
  
    // If the attribute does not exist, terminate
    if(!isset($this->aAttributes[$sAttribute])) return "error92";
    
    // If it does exist, return the value of the attribute
    $uValue =  $this->aAttributes[$sAttribute]->getValue();
    
    // If the attribute is a foreign key, return the object it's referring to
    if($this->aAttributes[$sAttribute]->bForeignKey && $uValue) return new dbObject($sAttribute, $uValue);
    
    // If not, return the value
    return $uValue;
  }

   /**
   * Function to set an attribute of the object
   * @param(sAttribute) String, the name of the column of the attribute to be changed
   * @param(uValue) Unknown filetype depending on the attribute, the value in which the attribute should be set
   */
  public function setAttribute($sAttribute,$uValue) {
    if(is_null($uValue) || $uValue == 'null') $this->aAttributes[$sAttribute]->setNull();
    // If the attribute exists, it has to be set
    else if(isset($this->aAttributes[$sAttribute]) && is_object($this->aAttributes[$sAttribute]))
      $this->aAttributes[$sAttribute]->setValue($uValue);
      
    // If not, terminate and give feedback
    else {
 	echo 'error92';
      return "error92";
    }
  }
  /**
  * Function to save an object to the database
  */
  public function save() {
  
    if($this->getAttribute('sKeyName')>0) {
      // Use the replace into syntax if the object already exists
      $sSql="REPLACE INTO `".$this->sDataBase."`.`".$this->sTablename."` SET ";
      
      // For each attribute a string has to be made for the mysql save syntax
      foreach($this->aAttributes as $oAttribute) {
	if(!is_object($oAttribute)) continue;
	
	// The formatting of the string is done in dbAttribute
	$sSql.= " `".$oAttribute->sName."` = ".$oAttribute->formatQuotes().",";
      }
      // Remove last comma
      $sSql=substr($sSql,0,-1);
      
      
    // Execute query
      mysql_query($sSql);
    
    } else {
    
      // Use the insert into syntax if it is a new object
      $sSql="INSERT INTO `".$this->sDataBase."`.`".$this->sTablename."` SET ";
      
      // For each attribute a string has to be made for the mysql save syntax
      foreach($this->aAttributes as $oAttribute) {
	if(!is_object($oAttribute) || $oAttribute->sName == $this->sKeyName) continue;
	
	// The formatting of the string is done in dbAttribute
	$sSql.= " `".$oAttribute->sName."` = ".$oAttribute->formatQuotes().",";
      }
      // Remove last comma
      $sSql=substr($sSql,0,-1);
      
      
      // Execute query
      mysql_query($sSql);
      
      // set own id
      self::setAttribute($this->sKeyName,mysql_insert_id());
    
    }
  }
  
  /**
  * Function to delete an object from the database
  */
  public function delete() {
    // Delete the entry from the database
    $sSql="DELETE FROM `".$this->sDataBase."`.`".$this->sTablename."` WHERE `".$this->sKeyName."` = ".self::getAttribute($this->sKeyName).";";

   // Execute query
    mysql_query($sSql);
    // Keep the current object and set its key to 0
    self::setAttribute($this->sKeyName,0);
  }
}

?>