/**
 * Copyright (c) 2012 Anan6 BV
 * 
 * @Author 		R.S. Plak 	rutger.plak@anan6.com
 * @Copyright 		Anan6 BV	info@anan6.com / larry.poort@anan6.com
 * 
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
 * and associated documentation files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies 
 * or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 */

// global variable for debugging (generating output)
var bDebug = false;
// webservice URL
var sWebservice = 'q.php'; 

/**
 * function representing an object from the database
 * @param(sTableName) String consisting of the databasename and the tablename
 * @param(iId) Identifier of the requested entry
 */
function db(sTableName, iId) {
  // private variable for referencing to own object
  var __dbobject = this;
  // private variable; number of attributes
  var iAttributes = 0;
  // private array of attributes
  this.aAttributes = [];
  // identifier of the object (public)
  this.iId = null;
  // tablename of the object (public)
  this.sTableName = null;
  // keep track of the keyname for saving
  this.sKeyName = null;
  
  /**
   * public function to get all attributes
   * used by the get function and the save function
   */
  this.getAttributes = function() {
    
    var __attributes = this;
    var attributes = {}
    var count = 0;
    for(var i in __dbobject.aAttributes) {
      if(__dbobject.aAttributes[i]) attributes[i] = __dbobject.aAttributes[i].getValue();
      count++;
      if(count==iAttributes) {
        //return attributes;
        __attributes = attributes; 
	return __attributes;
      }
    }
  }
    
  /**
   * public function to get the value of an attribute
   * @param(sName) name of the requested attribute
   */
  this.getAttribute = function(sName) {
    // if the object is initialized, return the value. If not, 
    if(__dbobject['__'+sName] && arguments.length==1) return __dbobject['__'+sName]();
    else if(__dbobject['__'+sName] && arguments.length==2 && typeof arguments[1] == 'function') {
      return __dbobject['__'+sName](arguments[1]);
       
    } else {
      // no attribute? return nothing
      return null;
    }
    
  }

  /**
   * public function to set the value of an attribute
   * @param(sName) name of the attribute to be set
   * @param(uValue) new value of the attribute
   */
  this.setAttribute = function(sName,uValue) {
    // set the value and return the object for chaining
    if(__dbobject['__'+sName])  {
     __dbobject['__'+sName](uValue);
    }
    return __dbobject;
  }
    
  
  /**
   * private function to save the object to the database
   * @param(attributes) generated array with attributes
   */
  var toDatabase = function(attributes, callback) {
    // making the databasecall
    $.post(sWebservice+'?timestamp='+new Date().getTime(), {
    'action': "sav",
    'data': {
      'tablename': sTableName,
      'identifier': __dbobject.iId?__dbobject.iId:0,
      'attributes': attributes
      }
    }, function(data) {
      // debugging 
      if(data && data['status']=='error') {
	debug(data);
	__dbobject = null;
	return false;
      } else if(data){
	__dbobject.iId = data['identifier'];
	__dbobject.setAttribute(__dbobject.sKeyName,data['identifier']);
	if(callback) callback(__dbobject);
      
	console.log('succesvol opgeslagen');
      }
    }, 'json'); 
    return __dbobject;
  }
  
  /**
   * public function to save the object to the database
   * generates an array of the attributes and calls the toDatabase function
   */
  this.save = function(callback) {
    toDatabase(__dbobject.getAttributes(),callback);
    return __dbobject;
  }
  /**
   * public function to delete the object from the database
   */
  this.remove = function(callback) {
    var iId = __dbobject.iId?__dbobject.iId:(__dbobject.getAttribute(__dbobject.sKeyName)?__dbobject.getAttribute(__dbobject.sKeyName):'null');
    if(!iId) return;
    $.post(sWebservice+'?timestamp='+new Date().getTime(), {
    'action': "del",
    'data': {
      'tablename': sTableName,
      'identifier' : iId
    }
  }, function(data) {
    __dbobject.bIdle = true;
    // debugging 
    if(data['status']=='error') {
      debug(data);
      __dbobject = null;
      return false;
    } else {
      if(callback) callback(__dbobject.getAttribute(__dbobject.sKeyName));
      console.log('succesvol verwijderd');
    }
  }, 'json'); 
  }
   
    
  // catch non existing function calls (firefox only)
  __noSuchMethod__ = function(id, args) {
    console.log('No such function: '+id); 
  }
  
    /**
   * private function __dbobject initializes the object after the databasecall
   * @param(data) data from the database
   */
  var initialize = function(data, callback) {
    var iTotalAttributes = 0;
    for (var k in data['aAttributes']) 
      if (data['aAttributes'].hasOwnProperty(k)) 
	++iTotalAttributes;
	
    
    // initializing each variable
    for(var i in data['aAttributes']) {
      if(data['aAttributes'][i]['bPrimaryKey']) __dbobject.sKeyName = data['aAttributes'][i]['sName'];
      iAttributes++;
      // adding get and set function
      __dbobject['__'+i] = getGetFunction(i);
    
      // adding a dbAttribute to the attributes array
      __dbobject.aAttributes[i] = new dbAttribute(data['aAttributes'][i]);
      //__dbobject[i] = data['aAttributes'][i]['uValue'];
      // if done, change status 
      if(iAttributes == iTotalAttributes) {
	if(callback) {
	  callback(__dbobject);Clem	Hello dbQuery !!
	}
      }
     }
  }
  
  /**
   * Function that dynamically creates a function to return the attribute 
   */
  var getGetFunction = function(i) {
     return function() {
      var __attribute = null;
      if(arguments.length==0) {
	  if(__dbobject.aAttributes[i].bForeignKey) {
	    __attribute = new db(i,__dbobject.aAttributes[i].getValue());
	  } else {
	    // if not, return the value of the attribute
	    __attribute = __dbobject.aAttributes[i].getValue();
	  }
	} else if(arguments.length==1) {
	  // setfunction
	  if(typeof arguments[0] != 'function') {
	    __attribute = __dbobject;
	    __dbobject.aAttributes[i].setValue(arguments[0]);
	  // getfunction with callback
	  } else if (typeof arguments[0] == 'function' && __dbobject.aAttributes[i].bForeignKey) {
	    __attribute = new db(i,__dbobject.aAttributes[i].getValue(), arguments[0]);
	  } 
	 
	} 
	return __attribute;
      } 
  }
  
  // initialize if it is a NEW db object
  if(__dbobject instanceof db && arguments.length>0) {
    // if only data is passed, initialize directly
    if(arguments.length == 1 && arguments[0]['aAttributes']) {
      initialize(arguments[0]);
      return __dbobject;
    }
    
    // extract parameters
    if(arguments[0]) var sTableName = arguments[0];
    if(arguments[1]) var uSelection = typeof(arguments[1])=='function'?null:arguments[1];
    if(arguments[2]) var callback = typeof(arguments[1])=='function'?arguments[1]:arguments[2];
    
    
    
     // if data is passed, initialize directly.
    if(sTableName && typeof(sTableName)!= 'string' && typeof(arguments) != 'string') {
      initialize(arguments, callback);
      // if data isn't passed, fetch data from the server
    } else {
      this.iId = iId;
    
      // tablename of the object (public)
      this.sTableName = sTableName;
      
      // Constructor
      // making the databasecall to extract the object from the database
      $.post(sWebservice+'?timestamp='+new Date().getTime() , {
        'action': "get",
        'data': {
          'tablename': sTableName,
          'identifier': iId?iId:"null"
        }
      },
      function(data) {
        // giving error feedback
        if(data['status']=='error') {
          debug(data);
          __dbobject = null;
          return false;
        } else {
          debug(data);
          // initialize variables
          initialize(data['result']['resultset'][0], callback);
        }
        
      }, 'json');
    
    }
  } else if(arguments.length > 0){
    // extract parameters
    if(arguments[0]) var sTableName = arguments[0];
    if(arguments[1]) var uSelection = typeof(arguments[1])=='function'?null:arguments[1];
    if(arguments[2]) var callback = typeof(arguments[1])=='function'?arguments[1]:arguments[2];
    
    
      // check how many arguments are passed
    if(arguments.length==0) {
	// terminate
        __dbobject = null;
        return false;
    } else if(sTableName && !uSelection) {
	// could be a string. Empty object of databasetable is created
        if(sTableName instanceof String) {
          var returnArray = [];
	  // add it to return array
          returnArray.push(new db(sTableName));
	  // referencing it to '__dbobject' (this)
          __dbobject = returnArray;
	  return __dbobject;
	  
	  // it could be an object with selectioncriteria
        } else if(sTableName instanceof Object) {
	  
        }
      } else if(sTableName && uSelection) {
	
      // two arguments, one string and one integer (tablename + identifier)
        if(typeof sTableName == "string" && typeof uSelection == 'number') {
          
	  // rebuild query  
	  return db(sTableName, {'identifier':uSelection}, callback);
	  
	  // tablename and array of identifiers
        } else if(typeof sTableName == "string" && uSelection instanceof Object) {
	    $.post(sWebservice+'?timestamp='+new Date().getTime(), {
		    'action': "get",
		    'data': {
		      'tablename': sTableName,
		      'attributes': uSelection
		    }
	    }, function(data) {
	      // debugging 
	      if(data['status']=='error') {
		debug(data);
		return false;
	      } else {
		var returnArray = [];
		for(var i in data['result']['resultset']) {
		  returnArray.push(new db(data['result']['resultset'][i]));
	      }
	      returnArray.found = data['result']['found'];
	      callback(returnArray);
	    }
	  }, 'json');
        }
    }
  }
    
  // return itself
  return this;
 
}

/**
 * function to output debug information
 */
function debug(data) {
  if(bDebug) {
   console.log(data['msg']);
    if(data['status'] == 'error') {
      console.log('Error occurred. Received data:');
      console.log(data);
    }
  }
}


/**
 * function representing an attribute of an object from the database
 * @param(data) Databasedata extracted from the column and the internal table information
 */
function dbAttribute(data) {
  // private variable for self referencing
  var __attribute = this;
  // constructor
  // adding all properties from the attribute
  if(data && typeof(arguments[0]) != 'string') {
    for(var i in data) 
      this[i] = data[i];    
  }
  
  /**
   * public function to get the value of the attribute
   */
  this.getValue = function() {
   /* return this.uValue instanceof db?
	      this.uValue:
	      (this.bNull=='YES'?
		  __attribute.uValue: // if nullable, return the value
		  (__attribute.uValue?
		    __attribute.uValue:	 // if the value is set, return the value
		    (/date|time/gi.test(__attribute.sType)?
                    createDate(__attribute.uDefault)
                :__attribute.uDefault) // if not nullable and there is no value; return default
	      ));*/
   if(__attribute.uValue instanceof db) return __attribute.uValue;
   if(/date|time/.test(__attribute.sType)) return createDate(__attribute.uValue?__attribute.uValue:__attribute.uDefault);
   if(__attribute.bNull=='YES') return __attribute.uValue;
   if(!__attribute.uValue) return __attribute.uDefault;
   return __attribute.uValue;
	      
	return this.uValue instanceof db ? this.uValue :
	  (/date|time/.test(__attribute.sType) ?
	createDate(__attribute.uValue?__attribute.uValue:__attribute.uDefault) :
	(__attribute.bNull=='YES'?__attribute.uValue:__attribute.uDefault)); 
	
  }
 
    var createDate = function(newValue) {
      if(newValue==null) return null;
      var newDate =(newValue instanceof Date)?newValue:new Date(Date.parse(newValue.replace(/\-/gi,'/')));
      if(newDate != 'Invalid Date') return newDate;
      else if(newValue == 'CURRENT_TIMESTAMP') return new Date();
      else console.log('Invalid date set');
      return null;
    }
  /**
   * public function to set the value of the attribute
   * @param(newValue) new value of the attribute
   */
  this.setValue = function(newValue) {
    // convert dates
    if(/date|time/.test(__attribute.sType)) {
      var newDate = createDate(newValue);
      if(newDate instanceof Date) __attribute.uValue = newDate;
    } else {
      __attribute.uValue = newValue;
    }
  }
  
  // If the attribute is a date, it has to be set according to it's value or default (if not nullable)
  if(/date|time/.test(__attribute.sType)) {
    __attribute.uValue = __attribute.uValue?createDate(__attribute.uValue):(__attribute.bNull=='YES'?null:createDate(__attribute.uDefault));
    //__attribute.uValue = this.bNull=='YES'?(__attribute.uValue?new Date(__attribute.uValue):__attribute.uDefault?(__attribute.uDefault):null):(new Date(__attribute.uValue?__attribute.uValue['date']:null));
  }   
    
  // return itself
  return this;
}