<?
require_once('dbquery.config'); 
define('DEFAULT_DB',$__DEFAULT_DATABASE);
require_once($__PATH_TO_DBOBJECT.'/dbObject.inc.php');
require_once($__PATH_TO_DBOBJECT.'/dbAttribute.inc.php');

$oLink=mysql_connect($__HOST_OF_THE_DATABASE, $__USER_OF_THE_DATABASE, $__PASSWORD_OF_THE_DATABASE);
if(!$oLink) die("Could not connect: " . mysql_error());
mysql_select_db(DEFAULT_DB);
$bReadOnly = $__READ_ONLY_MODE;

/**
 * Class used for creating error-json messages and for the storage of success messages
*/
class dbMessage {
  
  private $sCode = null;
/**
  * Array with error messages at errorcode index.
  * @var Array[string,string]
  */
  public $aError = array(
    "error90" => "No (valid) action specified specified. Set 'action' to the requested action. Possible actions are 'get', 'sav(e)' and 'del(ete)'.",
    "error91" => "No (valid) table name provided. Set 'tablename' to the requested table name.",
    "error92" => "An invalid attribute was added to the object.",
    "error94" => "An error occurred while executing the mysql-query.",
    "error95" => "An error occurred while reading the database internal information",
    "error96" => "The database you provided does not exist. Set 'database' to the requested database or don't send a database to use the default database.",
    "error97" => "No database modifications allowed"
  );

  /**
  * Array with success messages at action string index.
  * @var Array[string,string]
  */
  public $aMsg = array(
    "get" => "The requested item(s) ha(s)(ve) been succesfully loaded from the database.",
    "sav" => "The item has been succesfully saved in the database.",
    "del" => "The item has been succesfully deleted from the database."
  );
  
  public function dbMessage($sCode) {
     $this->sCode = $sCode; 
  }
  
  
  /**
  * returns an array with error indication and explaination
  * @param(iError) Errorcode
  * @return array with useful error information
  */
  public function doError() {
    // return an array with error information
    return array(
      "status" => "error",
      "errordetails" =>  array(
	"code" => $this->sCode,
	"msg" => $this->aError[$this->sCode]
      )
    );
  }
  
  /**
  * returns an array with error indication and explaination
  * @param(iError) Errorcode
  * @return array with useful error information
  */
  public function getMessage($sMessage) {

    return $this->aMsg[$sMessage];
  }
}

/**
 * Determing which function to call depending on the requested action
 * Echo's json encoded strings of the requested information
 */
switch(substr($_REQUEST['action'],0,3)) {
  case 'get':
    echo json_encode(doGet($_REQUEST));
    break;
  case 'sav':
    if($bReadOnly) {
      $oError = new dbMessage("error97");
      die( json_encode($oError->doError()) );
    } else echo json_encode(doSave($_REQUEST));
    break;
  case 'del':
    if($bReadOnly) {
      $oError = new dbMessage("error97");
      die( json_encode($oError->doError()) );
    } else echo json_encode(doDel($_REQUEST));
    break;
  default:
    $oError = new dbMessage("error90");
    
    echo json_encode($oError->doError());
}


/**
 * returns object(s) meeting search criteria
 * @param(aParams) All request headers with information about the search
 * @return array with all information needed
 */
function doGet($aParams) {
  // The tablename is extracted from the headers
  $sTableName = $aParams['data']['tablename'];
  
  // The identifier is extracted from the headers
  $iId = $aParams['data']['identifier'];
  
  // If attributes are passed instead of an identifier, a global get is used
  if(!is_array($aParams['data']['attributes'])) {
    $oReturn = new dbObject(strstr($sTableName,'.')?$sTableName:DEFAULT_DB.'.'.$sTableName,$iId);
  } else {
    //echo 'Ik ga de GET uitvoeren...'.PHP_EOL;
    $oReturn = new dbObject(strstr($sTableName,'.')?$sTableName:DEFAULT_DB.'.'.$sTableName);
    //echo 'Object geinitialiseerd...'.PHP_EOL."Attributen zetten...".PHP_EOL;
    //echo 'Meegeleverde attributen: '.implode(',',$aParams['data']['attributes']).PHP_EOL;
    foreach($aParams['data']['attributes'] as $sKey => $sValue) {
    
      switch($sKey) {
          case 'orderby':
          case 'size':
          case 'offset':
          case 'identifier':
          $oReturn->$sKey = $sValue;
          break;
          default:
          
          $oReturn->setAttribute($sKey,$sValue); 
       }
    }
    return buildReturn(dbObject::get($oReturn));
  
  }
  
  // If something went wrong at dbObject, an errorcode will be returned
  if(is_string($oReturn) && substr($oReturn,0,5)=='error') {
    $oError = new dbMessage($oReturn);
    return $oError->doError();
  }
  
  // make an array of the return values and send it back
  return buildReturn($oReturn);
}

/**
 * saves changes made to an object in the database
 * @param(aParams) All request headers with information about the object
 * @return succes or failure array
 */
function doSave($aParams) {

  // table name is requested from the headers
  $sTableName = $aParams['data']['tablename'];
  
  // identifier is requested from the headers
  $iId = $aParams['data']['identifier'];
  
  // create the object to be requested
  $oObject = new dbObject(strstr($sTableName,'.')?$sTableName:DEFAULT_DB.'.'.$sTableName,$iId);
  
  // set all the attributes of the object to the new values
  $aAttributes = $aParams['data']['attributes'];
  
  foreach($aAttributes as $sKey => $sValue) {
    $oObject->setAttribute($sKey,get_magic_quotes_gpc()?stripslashes($sValue):$sValue);
  }
  
  
  // save the object
  $oReturn = $oObject->save();
  
  
  // if something went wrong at dbObject, an errorcode will be returned
  if(is_string($oReturn) && substr($oReturn,0,5)=='error') {
    $oError = new dbMessage($oReturn);
    return $oError->doError();
  }
  
  
  $oMessage = new dbMessage();
  // build and return the array
  $aResult = array(
    "status" => "success",
    "msg" => $oMessage->getMessage('sav'),
    "action" => 'save',
    "identifier" => $oObject->getAttribute($oObject->sKeyName)
  );
  die(json_encode($aResult));
  return $aResult;
}

/**
 * deletes the given object from the database
 * @param(aParams) All request headers with information about the object
 * @return succes or failure array
 */
function doDel($aParams) {

  // tablename is requested from the headers
  $sTableName = $aParams['data']['tablename'];
  
  // identifier is requested from the headers
  $iId = $aParams['data']['identifier'];
  
  // create the object to be deleted
  $oObject = new dbObject(strstr($sTableName,'.')?$sTableName:DEFAULT_DB.'.'.$sTableName,$iId);
  
  // delete the object
  $oReturn = $oObject->delete();
  
  // if an error occurred at dbObject, an errorcode will be returned
  if(is_string($oReturn) && substr($oReturn,0,5)=='error') {
    $oError = new dbMessage($oReturn);
    return $oError->doError();
  }
  
  $oMessage = new dbMessage();
  // create array with feedback information
  $aResult = array(
    "status" => "success",
    "msg" => $oMessage->getMessage('del'),
    "action" => 'delete'
  );
  return $aResult;
  
}



/**
 * returns an array that can be easily parsed to json
 * @param(aResult) Resultste of the query
 * @return array with all data to be sent
 */
function buildReturn($oResult) {

  // prepare resultset
  $oResultSet = array();
  $oMessage = new dbMessage('get');
  
  
  // if there are multiple results, they are stored in an iterator
  if($oResult instanceof ArrayIterator) $oResultSet = iterator_to_array($oResult);
    
    
  // if it is not an iterator, it is a single object
   else 
    $oResultSet[] = $oResult;
    
  
  // prepare array
  $aResult = array(
    "status" => "success",
    "msg" => $oMessage->getMessage('get'),
    "action" => 'get',
    "result" => array(
	"found" => $oResult->found?$oResult->found:'',
	"resultset" => $oResultSet
     )
  );
  
  return $aResult;
}
?>